<?php

define('MAX_SITEMAP_ITEM',1000);

function sitemap_xml_page(&$page_ar)
{
	global $database,$params,$config,$p_circle,$html,$ut;

	header("Content-Type: text/xml; charset=utf-8"); 
	
	$buff = '';

$buff .= <<<EOT
<?xml version="1.0" encoding="UTF-8" ?>
<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<!--  Generated by OneThird CMS  --> \n
EOT;

	$p_page = $params['circle']['meta']['top_page'];
	$ar = $database->sql_select_all( "select block_type,date,metadata,link,title,type,id,pv_count from ".DBX."data_items where id=? ", $p_page );
	if ( !$ar ) {
		exit_proc(404);
	}

$buff .= <<<EOT
<url>
  <loc>{$params['circle']['url']}</loc>
  <priority>1.0</priority>
  <changefreq>daily</changefreq>
</url>\n
EOT;

	$buff .= get_sitemap_tree(0, $nest);

$buff .= <<<EOT
</urlset>
EOT;

	echo $buff;
	exit();

}
function get_sitemap_tree( $p_page, &$nest)
{
	global $database,$params,$config,$p_circle,$plugin_ar,$ut;
	
	if ( ++$nest > MAX_PAGE_NEST ) {
		return '';
	}

	$buff = '';
	$link = $p_page;

	$limit = MAX_SITEMAP_ITEM;
	if (isset($plugin_ar[SITEMAPXML_ID]['limit'])) {
		$limit = (int)$plugin_ar[SITEMAPXML_ID]['limit'];
	}
	
	$sql = array();
	$sql[] = "select pv_count,mode,id,link,title,type,block_type,{$ut->date_format("mod_date", "'%Y/%c/%d'")} as d from ".DBX."data_items ";
	$sql[] = array(" where circle=? ", $p_circle);
	$sql[] = array(" and mode=1 and block_type<>5 and block_type < 19 and block_type <> 0 and type<> ?", HIDDEN_ID);
	if ($p_page) {
		$sql[] = array(" and link = ? ", (int)$p_page);
	}
	$sql[] = array(" order by mod_date desc limit ?", $limit);
	$ar = $database->sql_select_all( $sql );
	if ( !$ar ) {
		return '';
	}
	
	$pv_active = check_rights('edit') && isset($params['circle']['meta']['pv_logging']);
	foreach ( $ar as $v ) {
		if ($v['mode'] != 1) { continue; }
		if ($v['type'] != HIDDEN_ID) {

			$u = $ut->link($v['id']);

$buff .= <<<EOT
<url>
<loc>$u</loc>
<priority>0.8</priority>
</url>\n
EOT;
		}
		if ($p_page != $v['id']) {
			$buff .= get_sitemap_tree($v['id'], $nest);
			--$nest;
		}

$buff .= <<<EOT
EOT;
	}

	return $buff;
}

?>